(* ProofFinal, corresponding to the Corollary in Section 3.3,
   proves BigErrorStep <-> BigErrorTrace *)



Require Import SemanticsBase.
Require Import SemanticsState.
Require Import SemanticsTrace.
Require Import ProofBase.
Require Import ProofStateToTrace.
Require Import ProofTraceToState.



(* ~~~~~~~ BIGERRORSTEP IFF BIGERRORTRACE ~~~~~~~ *)

Definition iff_type (A B : Type) := ((A -> B) * (B -> A))%type.

Notation "A <-> B" := (iff_type A B) : type_scope.

Definition BigErrorStep_iff_BigErrorTrace {P} (i : initial P)
                                          : BigErrorStep P <-> BigErrorTrace P :=
  (fun bes =>
   match bes in BigErrorStep P return initial P -> BigErrorTrace P with
     | BES _ _ _ bs es =>
   fun i => BET _ _ (BigStep_to_BigTrace bs (initial_to_valid i) (initial_to_exact i))
                    (ErrorStep_to_ErrorTrace es (BS_Valid bs (initial_to_valid i))
                               (BS_Exact bs (initial_to_valid i) (initial_to_exact i)))
   end i,
   fun bet =>
   match bet in BigErrorTrace P return initial P -> BigErrorStep P with
     | BET _ _ bt et =>
   fun i => match BigTrace_to_BigStep (initial_to_valid i) bt with
              | inl bs =>
                BES _ _ _ (eq_rect_r (fun x => BigStep _ x _ _) bs (eq_sym (initial_to_nil i)))
                          (ErrorTrace_to_ErrorStep et)
              | inr (existT _ (existT _ (bs, es))) =>
                BES _ _ _ (eq_rect_r (fun x => BigStep _ x _ _) bs (eq_sym (initial_to_nil i))) es
            end
   end i).

Print Assumptions BigErrorStep_iff_BigErrorTrace.