(* ProofTraceToStateInterferance maps
   interferant Traces to ErrorSteps,
   defining:
    - TraceInt_to_ES *)



Require Import List.
Require Import SemanticsBase.
Require Import SemanticsState.
Require Import SemanticsTrace.
Require Import ProofPre.
Require Import ProofBase.
Require Import ProofTraceToStateBase.



(* ~~~~~~~ INTERFERANT TRACES TO ERRONEOUS STEPS ~~~~~~~ *)

Definition req_ll_comm {a a' s} (r : req (ll a a') s) : req (ll a' a) s :=
  proj1 (and_comm _ _) r.

Fixpoint TraceInt_to_DownCount {P P' a l} (t : Trace P a P') (r : req a l) (i : interferant a)
                                             : {p : Probe & In p (down a) /\ count_occ eq_Probe_dec (pre a) p > 1} :=
  match t in Trace P a P' return req a l -> interferant a -> _ with
    | CommB2_T A => fun _ => fun i => match i with existT _ (conj iu _) => match in_nil iu with end end
    | CommQ2_T A => fun _ => fun i => match i with existT _ (conj iu _) => match in_nil iu with end end
    | Sequ_T _ _ q _ t' => fun r => fun i => TraceInt_to_DownCount t' r i
    | Par_T _ _ _ _ a0 a1 t0 t1 => fun r => fun i =>
                                   match i with existT p (conj iu id) =>
                                   match in_dec eq_Probe_dec p (up a0), in_dec eq_Probe_dec p (down a0),
                                         in_dec eq_Probe_dec p (up a1), in_dec eq_Probe_dec p (down a1) with
                                     | left iu0, left id0, _, _ => match TraceInt_to_DownCount t0 (proj1 r) (existT _ p (conj iu0 id0)) with
                                                                   existT p (conj id c) => existT _ p (conj (in_or_app _ _ _ (or_introl id))
                                                                                                            (eq_ind_r (fun x => x > 1) (plus_gt_one (or_introl c)) count_occ_app)) end
                                     | _, _, left iu1, left id1 => match TraceInt_to_DownCount t1 (proj2 r) (existT _ p (conj iu1 id1)) with
                                                                   existT p (conj id c) => existT _ p (conj (in_or_app _ _ _ (or_intror id))
                                                                                                            (eq_ind_r (fun x => x > 1) (plus_gt_one (or_intror (or_introl c))) count_occ_app)) end
                                     | left iu0, _, _, left id1 => existT _ p (conj id (eq_ind_r (fun x => x > 1)
                                                                                                 (plus_gt_one (or_intror (or_intror (conj
                                                                                                 (proj1 (count_occ_In _ _ _) (Labels_to_pre (req_ll_comm r) id1 iu0))
                                                                                                 (proj1 (count_occ_In _ _ _) (down_to_pre id1))))))
                                                                                                  count_occ_app))
                                     | _, left id0, left iu1, _ => existT _ p (conj id (eq_ind_r (fun x => x > 1)
                                                                                                 (plus_gt_one (or_intror (or_intror (conj
                                                                                                 (proj1 (count_occ_In _ _ _) (down_to_pre id0))
                                                                                                 (proj1 (count_occ_In _ _ _) (Labels_to_pre r id0 iu1))))))
                                                                                                  count_occ_app))
                                     | right niu0, _, right niu1, _ => match match in_app_or _ _ _ iu with
                                                                               | or_introl iu0 => niu0 iu0
                                                                               | or_intror iu1 => niu1 iu1 end with end
                                     | _, right nid0, _, right nid1 => match match in_app_or _ _ _ id with
                                                                               | or_introl id0 => nid0 id0
                                                                               | or_intror id1 => nid1 id1 end with end end end
    | _ => fun _ => fun i => match i with existT _ (conj _ id) => match in_nil id with end end
  end r i.

Definition TraceInt_to_ES {P P' a} (t : Trace P a P') (c : compliant a) (i : interferant a) : ErrorStep P (pre a) :=
  match TraceInt_to_DownCount t c i with existT _ ic => TraceDownCount_to_ES t c ic end.